<template>
  <b-container>
    <HeaderVendeur />
  </b-container>
  <b-container>
    <b-tabs content-class="mt-3">
      <b-tab
        title="PRODUITS"
        active
      >
        <b-row>
          <b-col 
            v-for="(produit, index) in produits"
            :key="produit"
            sm="12"
            md="4"
            class="h-100"
          >
            <CardProduit
              :id="produit.id"
              :id-vendeur="produit.vendeur.id"
              :titre="produit.titre"
              :prix="produit.prix"
              :image="images[index]"
            />
          </b-col>
        </b-row>
      </b-tab>
      <b-tab
        title="COMMENTAIRES"
        class="d-md-flex flex-row"
      >
        <section class="column-com mb-5">
          <div>
            <div
              v-for="(starfill, index) in numFillStars"
              :key="starfill"
              class="d-flex"
            >
              <div
                v-for="nfill in numFillStars[index]"
                :key="nfill"
              >
                <svg
                  xmlns="http://www.w3.org/2000/svg"
                  fill="#001A72"
                  viewBox="0 0 512.002 512.002"
                  data-v-76dea496=""
                  style="width: 17px; height: 17px;"
                ><path d="M511.267 197.258a14.995 14.995 0 00-12.107-10.209l-158.723-23.065-70.985-143.827a14.998 14.998 0 00-26.901 0l-70.988 143.827-158.72 23.065a14.998 14.998 0 00-8.312 25.585l114.848 111.954-27.108 158.083a14.999 14.999 0 0021.763 15.812l141.967-74.638 141.961 74.637a15 15 0 0021.766-15.813l-27.117-158.081 114.861-111.955a14.994 14.994 0 003.795-15.375z" /></svg>
              </div>
              <div
                v-for="nempty in numEmptyStars[index]"
                :key="nempty"
              >
                <svg
                  xmlns="http://www.w3.org/2000/svg"
                  fill="#DBDBDB"
                  viewBox="0 0 512.002 512.002"
                  data-v-76dea496=""
                  style="width: 17px; height: 17px;"
                ><path d="M511.267 197.258a14.995 14.995 0 00-12.107-10.209l-158.723-23.065-70.985-143.827a14.998 14.998 0 00-26.901 0l-70.988 143.827-158.72 23.065a14.998 14.998 0 00-8.312 25.585l114.848 111.954-27.108 158.083a14.999 14.999 0 0021.763 15.812l141.967-74.638 141.961 74.637a15 15 0 0021.766-15.813l-27.117-158.081 114.861-111.955a14.994 14.994 0 003.795-15.375z" /></svg>
              </div>
              <p class="mx-2 mb-0">
                {{ nbTotal[index] }} avis
              </p>
            </div>
          </div>
        </section>
        <section
          class="w-100"
          md="w-75"
        >
          <div v-if="comments.length">
            <div
              v-for="com in comments"
              :key="com"
              class="mb-4"
            >
              <div class="d-flex justify-content-between">
                <NomVendeur :idusercom="com.utilisateur_id" />
                <div class="d-flex">
                  <div
                    v-for="note in com.note"
                    :key="note"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      fill="#001A72"
                      viewBox="0 0 512.002 512.002"
                      data-v-76dea496=""
                      style="width: 17px; height: 17px;"
                    ><path d="M511.267 197.258a14.995 14.995 0 00-12.107-10.209l-158.723-23.065-70.985-143.827a14.998 14.998 0 00-26.901 0l-70.988 143.827-158.72 23.065a14.998 14.998 0 00-8.312 25.585l114.848 111.954-27.108 158.083a14.999 14.999 0 0021.763 15.812l141.967-74.638 141.961 74.637a15 15 0 0021.766-15.813l-27.117-158.081 114.861-111.955a14.994 14.994 0 003.795-15.375z" /></svg>
                  </div>
                  <div
                    v-for="empty in (5 - com.note)"
                    :key="empty"
                  >
                    <svg
                      xmlns="http://www.w3.org/2000/svg"
                      fill="#DBDBDB"
                      viewBox="0 0 512.002 512.002"
                      data-v-76dea496=""
                      style="width: 17px; height: 17px;"
                    ><path d="M511.267 197.258a14.995 14.995 0 00-12.107-10.209l-158.723-23.065-70.985-143.827a14.998 14.998 0 00-26.901 0l-70.988 143.827-158.72 23.065a14.998 14.998 0 00-8.312 25.585l114.848 111.954-27.108 158.083a14.999 14.999 0 0021.763 15.812l141.967-74.638 141.961 74.637a15 15 0 0021.766-15.813l-27.117-158.081 114.861-111.955a14.994 14.994 0 003.795-15.375z" /></svg>
                  </div>
                </div>
              </div>
              {{ com.commentaire }}
            </div>
          </div>
          <div v-else>
            <p>Soyez la première personne à laissez un commentaire!</p>
          </div>
          <b-form>
            <b-form-group>
              <vue3starRatings
                v-model="rating"
                star-color="#001A72"
                inactive-color="#DBDBDB"
                disable-click="true"
                step="1"
              />
            </b-form-group>
            <b-form-textarea
              id="textarea"
              v-model="commentaire"
              placeholder="Laisser un commentaire ..."
              rows="3"
              max-rows="6"
            />
            <div class="button d-flex justify-content-end mt-3">
              <button
                class="submit btn-cta"
                type="submit"
                @click.prevent="addComment($event)"
              >
                Envoyer
              </button>
            </div>
          </b-form>
        </section>
      </b-tab>
    </b-tabs>
  </b-container>
  <Modal
    ref="modalMsg"
    :message="message"
    :choix="false"
  />
</template> 

<script>
import HeaderVendeur from '@/components/HeaderVendeur.vue';
import NomVendeur from '@/components/NomVendeur.vue';
import axios from 'axios';
import { useStore } from '@/store/store';
import CardProduit from '@/components/CardProduit.vue'
import vue3starRatings from "vue3-star-ratings";
import Modal from '@/components/Modal.vue';


export default {

    components: {
      HeaderVendeur,
      CardProduit,
      vue3starRatings,
      Modal,
      NomVendeur
    },

    data() {

      return {
        produits: [],
        store: useStore(),
        pseudoSeller: '',
        rating: 0,
        url: process.env.VUE_APP_URL,
        commentaire: '',
        comments: [],
        numFillStars: [5, 4 ,3 ,2 ,1],
        numEmptyStars: [0, 1, 2 ,3 ,4],
        message: '',
        test: [],
        notes: [],
        images: [],
        nbTotal: [],
        nbOf5: [],
        nbOf4: [],
        nbOf3: [],
        nbOf2: [],
        nbOf1: []
      }

    },

    watch: {
        '$route.params.idVendeur': function () {
            this.loadData();
        },
    },

    mounted() {
      this.loadData();
    },

    methods: {

      loadData(){
        // check if profil of currentuser or not
      if(this.store.isConnected){
        this.store.fetchSeller(this.store.user.id).then( res => {
          this.produits = [];
          this.images = [];
          // if(this.store.seller.id == this.$route.params.idVendeur){
          //   if(this.store.seller.produits.length > 0){
          //     this.store.seller.produits.forEach(produit => {
          //       axios.get(this.url + "/api/produits/" + produit.id)
          //       .then(res => {
          //         this.produits.push(res.data);
          //       })
          //       .catch(err => {
          //           console.log(err)
          //       })
          //     });
          //   }
          // } else {
            axios.get(this.url + "/api/info_vendeurs/" + this.$route.params.idVendeur)
            .then(res => {
              this.pseudoSeller = res.data.utilisateur.pseudo;
              if(res.data.produits.length > 0){
                res.data.produits.forEach(produit => {
                  axios.get(this.url + "/api/produits/" + produit.id)
                  .then(res => {      
                    if(res.data.mediaObjects[0] == undefined){
                        this.images.push('noimg');
                    } else {
                        this.images.push(res.data.mediaObjects[0].contentUrl);
                    };
                    this.produits.push(res.data);
                  })
                  .catch(err => {
                      console.log(err)
                  })
                })
              }
            })
            .catch(err => {
                console.log(err)
            })
          // } 
        })
      }

      //get comments of seller
      axios.get(this.url + "/api/commentaire_vendeurs/getbyseller/" + this.$route.params.idVendeur)
      .then(res => {      
        let arr = res.data['hydra:member'];
        console.log(arr);
        for (let i = 0; i < arr.length; i++) {
          const comment = arr[i];
          this.comments.push(comment);
          this.notes.push(comment.note);
          }
          // compte des notes pour l'affichage à gauche des avis par note
          this.nbOf5 = this.notes.filter(note => note == 5);
                this.nbOf4 = this.notes.filter(note => note == 4);
                this.nbOf3 = this.notes.filter(note => note == 3);
                this.nbOf2 = this.notes.filter(note => note == 2);
                this.nbOf1 = this.notes.filter(note => note == 1);
                this.nbTotal.push(this.nbOf5.length, this.nbOf4.length, this.nbOf3.length, this.nbOf2.length, this.nbOf1.length);
      })
      .catch(err => {
          console.log(err)
      })
      },

      addComment(){
        console.log(this.store.user.id);
        axios.post(this.url + "/api/commentaire_vendeurs", {
          "utilisateur": "api/utilisateurs/" + this.store.user.id,
          "vendeur": "api/info_vendeurs/" + this.$route.params.idVendeur,
          "note": parseInt(this.rating),
          "commentaire": this.commentaire
        })
        .then( res => {
          this.message = 'Merci pour votre commentaire, celui-ci a bien été pris en compte'
          this.$refs.modalMsg.show = true;
          axios.get(this.url + "/api/commentaire_vendeurs/getbyseller/" + this.$route.params.idVendeur)
          .then(res => {      
            let arr = res.data['hydra:member'];
            this.comments = [];
            for (let i = 0; i < arr.length; i++) {
              const comment = arr[i];
              this.comments.push(comment);
              }
          })
          .catch(err => {
              console.log(err)
          })
        })         
        .catch(err => {
            console.log(err);
        })
      }

    }
    
  }
</script>

<style lang="scss" scoped>
.column-com {
  @media (min-width: 540px) {
    width: 33%;
  }
}
</style>
